#include "Map.h"
#include <fstream>
using namespace std;

Map::Map() {
	for(int r = 0; r < 10; r++) {
		for(int c = 0; c < 10; c++) {
			level[r][c] = 0;
		}
	}
}

void Map::loadMap(char *filename) {
	int whatIsA = (int)'A'; // to load back properly at all times
	ifstream TheFile(filename);
	if(!TheFile) {
		fprintf(stderr,"map file %s is missing\n",filename);
		exit(1);
	}
	char line[11]; // map width + 1
	for(int r = 0; r < 10; r++) {
		TheFile.getline(line,11,'\n');
		for(int c = 0; c < 10; c++) {
			level[r][c] = (int)(line[c])-whatIsA;
			if(level[r][c] < 0) {
				fprintf(stderr,"negative tile at %i,%i\n",c,r);
				level[r][c] = 0;
			}
		}
	}
	TheFile.close();
	printf("map loaded....\n");
}

const bool Map::isSolid(float x, float y) {
	int tilex = (int) x/48;
	int tiley = (int) y/48;
	if(tiley + 1 >= 10 || tilex + 1 >= 10 || tilex < 0 || tiley < 0) {
		return 1;
	}
	if(level[tiley][tilex] == 1 || level[tiley][tilex] == 2) {
		return 1;
	}
	return 0;
}

const bool Map::isUnbombable(int x, int y) {
	if(level[y][x] == 1) {
		return 1;
	}
	return 0;
}