#include "muffins.h"

void CGame::drawSprites() {
	//printf("Drawing sprites\n");
	for(int j = 0; j < NUM_PLAYERS; j++) {
		if(players[j].hp > 0) {
			// i.e. not dead
			SDL_Surface *temp = chars[players[j].gfx][players[j].heading];
			if(temp) {
				players[j].rect.x= (Sint16)players[j].x;
				players[j].rect.y= (Sint16)players[j].y;
				SDL_BlitSurface(temp,NULL,screen,&players[j].rect);
				//printf("Drew a sprite\n");
			}
		}
	}
	list <ActiveBomb*>::iterator bit;
	for(bit = bombs.begin(); bit != bombs.end(); bit++) {
		ActiveBomb *tb = *bit;
		SDL_Rect rect;
		rect.x = tb->x * 48;
		rect.y = tb->y * 48;
		rect.w = 48;
		rect.h = 48;
		SDL_BlitSurface(miscgfx[MISCGFX_BOMB],NULL,screen,&rect);
		//printf("Drew a bomb\n");
	}
}

void CGame::drawExplosions() {
	list <Explosion*>::iterator eit;
	SDL_Rect explRect;
	explRect.w = 48;
	explRect.h = 48;
	for(eit = explosions.begin(); eit != explosions.end(); eit++) {
		Explosion* te = *eit;
		// well, obv. we should draw a sprite at the start here
		/*for(int x = te->tx - te->range; x <= te->tx + te->range; x++) {
			for(int y = te->ty - te->range; y <= te->ty + te->range; y++) {
				if(!theMap.isUnbombable(x,y)) {
					if(tiledistance(x,y,te->tx,te->ty) < te->range) {
						explRect.x = x * 48;
						explRect.y = y * 48;
						SDL_BlitSurface(miscgfx[MISCGFX_EXPL],NULL,screen,&explRect);
					}
				}
			}
		}*/
		int x = 0;
		int y = 0;
		x = te->tx;
		y = te->ty;
		// FIXME: This could be changed into two loops. I'm on drugs
		for(int x = te->tx; x <= te->tx + te->range; x++) {
			// Check to the right
			if(!theMap.isUnbombable(x,y)) {
				if(tiledistance(x,y,te->tx,te->ty) < te->range) {
					explRect.x = x * 48;
					explRect.y = y * 48;
					SDL_BlitSurface(miscgfx[MISCGFX_EXPL],NULL,screen,&explRect);
				}
			}
		}
		for(int x = te->tx; x >= te->tx - te->range; x--) {
			// Check to the left
			if(!theMap.isUnbombable(x,y)) {
				if(tiledistance(x,y,te->tx,te->ty) < te->range) {
					explRect.x = x * 48;
					explRect.y = y * 48;
					SDL_BlitSurface(miscgfx[MISCGFX_EXPL],NULL,screen,&explRect);
				}
			}
		}
		x = te->tx;
		for(int y = te->ty; y >= te->ty - te->range; y--) {
			// Check to the north
			if(!theMap.isUnbombable(x,y)) {
				if(tiledistance(x,y,te->tx,te->ty) < te->range) {
					explRect.x = x * 48;
					explRect.y = y * 48;
					SDL_BlitSurface(miscgfx[MISCGFX_EXPL],NULL,screen,&explRect);
				}
			}
		}
		for(int y = te->ty; y <= te->ty + te->range; y++) {
			// Check to the south
			if(!theMap.isUnbombable(x,y)) {
				if(tiledistance(x,y,te->tx,te->ty) < te->range) {
					explRect.x = x * 48;
					explRect.y = y * 48;
					SDL_BlitSurface(miscgfx[MISCGFX_EXPL],NULL,screen,&explRect);
				}
			}
		}
	}
}