#include "explosions.h"
#include "muffins.h"

Explosion::Explosion() {
	tx = 0;
	ty = 0;
	timer = 1200; // 1.2 seconds
	range = 2;
	owner = 0;
}

void CGame::handleExplosionTimers() {
	list <Explosion*>::iterator eit;
	for(eit = explosions.begin(); eit != explosions.end(); eit++) {
		Explosion* te = *eit;
		te->timer -= timer_elapsed;
		if(te->timer < 1) {
			// Explosion time out.
			// There is probably a better way to do this.
			explosions.remove(te);
			delete te;
			printf("Explosion timed out\n");
			return;
		}
	}
}

void CGame::wipeOutTiles(Explosion* e) {
	if(!e) {
		fprintf(stderr,"Invalid explosion provided\n");
		exit(1);
	}
	// Horizontal check.
	int x = e->tx;
	int y = e->ty;
	for(int x = e->tx - e->range; x <= e->tx + e->range; x++) {
		if(!theMap.isUnbombable(x,y)) {
			theMap.level[y][x] = 0;
		}
	}
	x = e->tx;
	for(int y = e->ty - e->range; y <= e->ty + e->range; y++) {
		if(!theMap.isUnbombable(x,y)) {
			theMap.level[y][x] = 0;
		}
	}
}