#include "SDL.h"
#include "SDL_image.h"
#include <cstdlib>
#include "muffins.h"
#include "weapons.h"

using namespace std;
int col = col;
int main(int argc, char *argv[]) {
	printf("Muffins by RavSoft\n");
	CGame game;
	game.gameLoop();
	printf("Bye\n");
	return 0;
}

CGame::CGame() {
	atexit(SDL_Quit);
	SDL_Init(SDL_INIT_VIDEO); // set us up, make sure every little thing is nice
	screen = SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
	if(!screen) {
		fprintf(stderr,"Could not initialize screen surface\n");
		exit(1);
	}
	SDL_WM_SetCaption("Muffins: Loading surfaces...","rav");
	loadSurfaces();
	SDL_WM_SetCaption("Muffins: Loading game data...","rav");
	SDL_WM_SetCaption("Muffins by Rav","rav");
	// maybe we should load the freakin' map in for now
	theMap.loadMap("data/map/demo.rav"); // just for the demo, once they hit something in the menu a new game will begin
	frames = 0;
	timer_start = 0;
	timer_elapsed = 0;
	timer_delta = 0;
	
	players[0].x = 48;
	players[0].y = 48;
	
	players[1].x = 8 * 48;
	players[1].y = 8 * 48;
	
	players[2].x = 48;
	players[2].y = 8 * 48;
	
	players[3].x = 8 * 48;
	players[3].y = 48;
	
	// Some debug shiznat
	ActiveBomb *newBomb = new ActiveBomb(2,0,7,8);
	newBomb->timer = 3000000;
	bombs.push_back(newBomb);
	
}

CGame::~CGame() {
	// Dump performance info to file
	float seconds = SDL_GetTicks()/1000.0f;
	float fps = frames/seconds;
	FILE* performance = fopen("performance.txt","a+");
	if(!performance) {
		fprintf(stderr,"Couldn't create performance file\n");
		exit(1);
	}
	fprintf(performance,"--New report--\n");
	fprintf(performance,"Time Running: %fs\n",seconds);
	fprintf(performance,"Frames: %i\n",frames);
	fprintf(performance,"Avg. FPS: %f\n",fps);
	fclose(performance);
	for(int c = 0; c < MAX_CHARS; c++) {
		for(int p = 0; p < 4; p++) {
			SDL_FreeSurface(chars[c][p]);
		}
	}
	for(int z = 0; z < MAX_MISCGFX; z++) {
		SDL_FreeSurface(miscgfx[z]);
	}
}