#include "muffins.h"
#include "weapons.h"
#include <math.h>
#include <list>
using namespace std;

const bool CGame::spriteCollision(float ax, float ay, float aw, float ah, float bx, float by, float bw, float bh) {
	float left1 = ax;
	float left2 = bx;
	float right1 = ax + aw;
	float right2 = bx + bw;
	float top1 = ay;
	float top2 = by;
	float bottom1 = ay + ah;
	float bottom2 = by + bh;
	
	if(bottom1 < top2) { return false; }
	if(top1 > bottom2) { return false; }
	if(right1 < left2) { return false; }
	if(left1 > right2) { return false; }
	
	return true;
}

const bool CGame::bombCollision(float x, float y, Uint32 team) {
	// Check to see if a moving NPC is hitting a bomb that is laid
	list <ActiveBomb*>::iterator bit;
	for(bit = bombs.begin(); bit != bombs.end(); bit++) {
		ActiveBomb *thisBomb = *bit;
		if(spriteCollision(x,y,2,2,thisBomb->x*48,thisBomb->y*48,48,48)) {
			if(team != thisBomb->owner) {
				return 1;
			} else {
				// perhaps some sort of 'kicking boot' feature here
			}
		}
	}
	return 0;
}

Uint32 CGame::bombsActiveForPlayer(Uint32 player) {
	int count = 0;
	list <ActiveBomb*>::iterator bit;
	for(bit = bombs.begin(); bit != bombs.end(); bit++) {
		ActiveBomb *tb = *bit;
		if(tb->owner == player) {
			count++;
		}
	}
	return count;
}

const bool CGame::canMoveTo(float x, float y, Uint32 p, bool bIsMovingRight, bool bIsMovingDown) {
	// Amazingly, adding the booleans worked a treat -- but oh dear jebus is it ever ugly
	// First, do some tile collision.
	if(theMap.isSolid(x+24,y+24)) { // Test in the centre of the sprite!!!
		return 0; // Hello!!!!!!!!!
	}
	// OK, now do some bomb collision
	if(bombCollision(x+24,y+24,p)) {
		return 0;
	}
	// Sweet, now let's get down to brass tacks and check the other players.
	for(int j = 0; j < NUM_PLAYERS; j++) {
		if((Uint32)j != p) {
			/*if(!bIsMovingRight && !bIsMovingDown) {*/
				if(spriteCollision(x+24,y+24,1,1,players[j].x,players[j].y,48,48)) {
					return 0;
				}
			/*}*/ /*else if(bIsMovingRight) {
				if(spriteCollision(x-36,y,36,36,players[j].x,players[j].y,36,36)) {
					return 0;
				}
			}
			else if(bIsMovingDown) {
				if(spriteCollision(x,y,36,36,players[j].x,players[j].y,36,36)) {
					return 0;
				}
			}*/
		}
	}
	return 1;
}

int CGame::tiledistance(int x1, int y1, int x2, int y2) {
	float dist = sqrt(((x2-x1)*(y2-y1))+((x2-x1)*(y2-y1)));
	return (int)dist;
}