#include "SDL.h"
#include "SDL_image.h"
#include "muffins.h"
#include <cstdlib>

void CGame::loadSurfaces() {
	// Load all the 48x48 characters
	for(int c = 0; c < MAX_CHARS; c++) {
		for(int p = 0; p < 4; p++) {
			char *filename = new char[30];
			sprintf(filename,"data/%i/%i.png",c,p);
			chars[c][p] = IMG_Load(filename);
			if(!chars[c][p]) {
				fprintf(stderr,"%s is missing\n",filename);
				exit(1);
			}
			SDL_Surface *temp = SDL_DisplayFormatAlpha(chars[c][p]);
			SDL_FreeSurface(chars[c][p]);
			chars[c][p] = temp;
			delete[] filename;
		}
	}
	// Load miscellaneous graphics
	for(int i = 0; i < MAX_MISCGFX; i++) {
		char *filename = new char[30];
		sprintf(filename,"data/misc/%i.png",i);
		miscgfx[i] = IMG_Load(filename);
		if(!miscgfx[i]) {
			fprintf(stderr,"%s missing\n",filename);
			exit(1);
		}
		SDL_Surface *temp = SDL_DisplayFormatAlpha(miscgfx[i]);
		SDL_FreeSurface(miscgfx[i]);
		miscgfx[i] = temp;
		delete[] filename;
	}
}